unit unit1;
interface

uses
  StrUtils, SysUtils,Types, Classes, QTypes,libc,inifiles,
  smtpsend,
  //DateUtils,mimepart,synautil,synachar,mimemess,
  
// blcksock, pop3send, 
 ssl_openssl
 ;
type
  ESMTP = class (Exception);


// e-mail template (subject and other headers+CRLF+CRLF+e-mail body) 
// in file sFileName

//From: ss@ss.com
//To: ss@ss.com.
//Subject: xxxxxxxxxxxxx
//Date: Sun, 26 Oct 2008 13:50:12 +0800
//MIME-Version: 1.0 (produced by Synapse)
// Content-type: text/plain; charset=UTF-8
// Content-Transfer-Encoding: 7bit
procedure MailSend(const sSmtpHost, sSmtpPort, sSmtpUser, sSmtpPasswd, 
                         sFromHeader, sReturnPath, sSubjectHeader, 
                         sContentTypeHeader, sContentTransferEncodingHeader,
                         sFileName: AnsiString;sToHeader: AnsiString;const Fsmtp:TSMTPSend);
                         

implementation

//-----------------------------------------------------------------------------------------
procedure _Reset( _LFSmtp:TSMTPSend);
begin
    writeln('Try Reset...');

if not _LFSmtp.Reset then begin writeln('SMTP ERROR: in SMTP Reset ... so abort ...' + _LFSmtp.EnhCodeString);exit;end;
    writeln('Reset OK!');
    writeln('');

end;
///////////////////////////////////////////////////////////////////////////////////////////
procedure MailSend(const sSmtpHost, sSmtpPort, sSmtpUser, sSmtpPasswd, 
                         sFromHeader, sReturnPath, sSubjectHeader, 
                         sContentTypeHeader, sContentTransferEncodingHeader,
                         sFileName: AnsiString; sToHeader: AnsiString;const Fsmtp:TSMTPSend);
                         
var ADDR_no,errorADDR_no:integer;errorADDR_str,SMTP_LOG_FILE,LOG_STRING:ansistring;SMTP_LOG_ERROR,SMTP_LOG_SENT:Boolean;
                         
//-----------------------------------------------------------------------------------------
procedure LMail(const FLIST_FILE,FReturnPath:ansistring;const Fmsg_lines:TStringList; LFSmtp:TSMTPSend);
var
  lst: TStringList;i,ii:integer;addr,addr_guid:string;GD:TGUID;HRS: HResult;
begin
//result:=false;
writeln('List '+FLIST_FILE+' entering...');
lst:=nil;
lst := TStringList.Create;
  try
  if fileexists(FLIST_FILE) then
  lst.loadfromfile(FLIST_FILE)else begin writeln('Cannot find file "'+FLIST_FILE+'" ... so abort ...');exit;end;
  trim(lst.text);
  //ADDR_no:=lst.count;
HRS:=CreateGUID(GD);
  
  for i:=0 to lst.count-1 do
  begin
//if  i=3 then exit;
errorADDR_str:='';
addr:=trim(lst[i]);
addr_guid:=addr+guidtostring(GD);
//writeln(addr_guid);
    if addr='' then inc(ii) else
    begin
    Fmsg_lines.delete(1);
    Fmsg_lines.insert(1,'To: ' + addr);

//if not LFSmtp.Reset then begin writeln('SMTP ERROR: in SMTP Reset ... so abort ...' + LFSmtp.EnhCodeString);exit;end;

    writeln('SMTP Sending ==> ['+inttostr(i+1)+'] '+addr);
    if not LFSmtp.MailFrom(FReturnPath, Length(FReturnPath)) then 
    begin 
    if addr_guid<>errorADDR_str then begin inc(errorADDR_no);errorADDR_str:=addr_guid;end;
    if SMTP_LOG_ERROR then LOG_STRING:=LOG_STRING+addr+' [ERROR in MailFrom]'+#13#10;writeln('SMTP ERROR: for address: '+addr+' in MailFrom:' + LFSmtp.EnhCodeString);_Reset(LFSmtp) ;continue;

    end;
    if not LFSmtp.MailTo(addr) then 
    begin 
    if addr_guid<>errorADDR_str then begin inc(errorADDR_no);errorADDR_str:=addr_guid;end;
    if SMTP_LOG_ERROR then LOG_STRING:=LOG_STRING+addr+' [ERROR in MailTo]'+#13#10;writeln('SMTP ERROR: for address: '+addr+' in MailTo:' + LFSmtp.EnhCodeString);_Reset(LFSmtp) ;continue;

    end;
    if not LFSmtp.MailData(Fmsg_lines) then 
    begin     
    if addr_guid<>errorADDR_str then begin inc(errorADDR_no);errorADDR_str:=addr_guid;end;
    if SMTP_LOG_ERROR then LOG_STRING:=LOG_STRING+addr+' [ERROR in MailData]'+#13#10;writeln('SMTP ERROR: for address: '+addr+' in MailData:' + LFSmtp.EnhCodeString);_Reset(LFSmtp) ;continue; 

    end;
    inc(ADDR_no);
    if SMTP_LOG_SENT then LOG_STRING:=LOG_STRING+addr+#13#10;
    end;
  end;  
  finally
    errorADDR_no:=(lst.count)-ADDR_no-ii;
    writeln('cleaning up...');
    if lst<>nil then begin lst.Free;
    lst:=nil;end;
    if lst=nil then writeln('lst = nil')else writeln('lst <> nil');
    //result:=true;
  end;

end;
//-----------------------------------------------------------------------------------------
procedure _setSMTP(const Aini:tinifile;ASMTP:TSMTPSend);
begin
  if Aini.valueexists('Main','SMTP_SSL')then ASMTP.FullSSL:=Aini.readBool('Main','SMTP_SSL',false);
  if Aini.valueexists('Main','SMTP_TIMEOUT')then ASMTP.timeout:=Aini.readinteger('Main','SMTP_TIMEOUT',5000);
  if Aini.valueexists('Main','SMTP_LOG_FILE')then SMTP_LOG_FILE:=Aini.readstring('Main','SMTP_LOG_FILE','');
  if Aini.valueexists('Main','SMTP_LOG_ERROR')then SMTP_LOG_ERROR:=Aini.readbool('Main','SMTP_LOG_ERROR',false);
  if Aini.valueexists('Main','SMTP_LOG_SENT')then SMTP_LOG_SENT:=Aini.readbool('Main','SMTP_LOG_SENT',false);
  
end;
//-----------------------------------------------------------------------------------------
var
  msg_lines: TStringList;ii:integer;ini:tinifile;sn:ansistring;

begin

  Fsmtp.timeout:=5000;
  
  //export RS_SYSTEM_RESOURCE_PATH=/opt/redstone/mainlib/resource
  //export RS_USER_RESOURCE_PATH=~/redstone/resource
  //writeln(libc.getenv('RS_USER_RESOURCE_PATH'));
  if length(libc.getenv('RS_USER_RESOURCE_PATH'))>0 then
  begin
  sn:=libc.getenv('RS_USER_RESOURCE_PATH');
  if LastDelimiter('/\',sn)<>length(sn)then sn:=sn+'/'+'XFGVCL_Mail_Implant_Properties' else sn:=sn+'XFGVCL_Mail_Implant_Properties';
  //writeln(sn);
  if fileexists(sn)then
  begin
  ini:=tinifile.create(sn);
  _setSMTP(ini,Fsmtp);
  end;
  end else
  if length(libc.getenv('RS_SYSTEM_RESOURCE_PATH'))>0 then
  begin
  sn:=libc.getenv('RS_SYSTEM_RESOURCE_PATH');
  if LastDelimiter('/\',sn)<>length(sn)then sn:=sn+'/'+'XFGVCL_Mail_Implant_Properties'else sn:=sn+'XFGVCL_Mail_Implant_Properties';
    if fileexists(sn)then
  begin
  ini:=tinifile.create(sn);
  _setSMTP(ini,Fsmtp);
  end;
  end;
  
  msg_lines:=nil;
  msg_lines := TStringList.Create;
  ii:=0;
  errorADDR_no:=0;
  try
    if fileexists(sFileName) then
    msg_lines.LoadFromFile(sFileName);
    msg_lines.Insert(0, 'From: ' + sFromHeader);
    inc(ii);
    msg_lines.Insert(ii, 'To: ' + sToHeader);inc(ii);
    if Length(sSubjectHeader)<>0 then begin
    msg_lines.Insert(ii, 'Subject: ' + sSubjectHeader);inc(ii);end;
    msg_lines.Insert(ii, 'User-Agent: FileGarden Mailer2 developed using Kylix and Synapse Pascal TCP/IP Library ( http://ararat.cz/synapse )');inc(ii);
    if Length(sContentTypeHeader)<>0 then begin
    msg_lines.Insert(ii, 'Content-type: ' + sContentTypeHeader);inc(ii);end;
    if Length(sContentTransferEncodingHeader)<>0 then begin
    msg_lines.Insert(ii, 'Content-Transfer-Encoding: ' + sContentTransferEncodingHeader);inc(ii);end;
    Fsmtp.AutoTLS:=true;
    Fsmtp.UserName := sSmtpUser;
    Fsmtp.Password := sSmtpPasswd;
 
    Fsmtp.TargetHost := sSmtpHost;
    Fsmtp.TargetPort := sSmtpPort;
 
    writeln('SMTP Login');
    writeln('');
    if not Fsmtp.Login() then begin writeln('Trying SMTP Full SSL ...');Fsmtp.FullSSL:=true; if not Fsmtp.Login() then begin writeln('SMTP ERROR: Login:' + Fsmtp.EnhCodeString);ADDR_no:=0;exit;end;ADDR_no:=0;exit;end;
{
    writeln('SMTP StartTLS');
    if not Fsmtp.StartTLS() then
      raise ESMTP.Create('SMTP ERROR: StartTLS:' + Fsmtp.EnhCodeString);
} 

//*****************************************************************************************
    if not Fsmtp.NoOp then begin writeln('SMTP ERROR: NoOp:' + Fsmtp.EnhCodeString);end;
//*****************************************************************************************

    //writeln('xxxxxxxxxxxxxxxxxxxxxxxxx'+sToHeader);
    if ansipos('%xfgMLST%',trim(sToHeader))>0 then begin 
    //procedure Delete(var S: string; Index, Count:Integer);
    sToHeader:=trim(sToHeader);
    delete(sToHeader,1,length('%xfgMLST%'));
    if (SMTP_LOG_FILE<>'')then LOG_STRING:='<============'+#13#10+'xfgmail 2 stated ['+datetostr(date)+'] ['+timetostr(now)+']'+#13#10+'[ list :: '+sToHeader+']'+#13#10+'[ content :: '+sFileName+']'+#13#10+'============>'+#13#10;
    //writeln('xxxxxxxxxxxxxxxxxxxxxxxxx'+sToHeader);
    LMail(sToHeader,sReturnPath,msg_lines,Fsmtp);end else
    begin
    if (SMTP_LOG_FILE<>'')then LOG_STRING:='<============ xfgmail 2 stated ['+datetostr(date)+'] ['+timetostr(now)+'] ============>'+#13#10;
    writeln('SMTP Sending ==> [1] '+sToHeader);
    if not Fsmtp.MailFrom(sReturnPath, Length(sReturnPath)) then begin if SMTP_LOG_ERROR then LOG_STRING:=LOG_STRING+sToHeader+' [ERROR in MailFrom]'+#13#10;writeln('SMTP ERROR: for address: '+sToHeader+' in MailFrom:' + Fsmtp.EnhCodeString);errorADDR_no:=1;exit;end;
    if not Fsmtp.MailTo(sToHeader) then begin if SMTP_LOG_ERROR then LOG_STRING:=LOG_STRING+sToHeader+' [ERROR in MailTo]'+#13#10;writeln('SMTP ERROR: for address: '+sToHeader+' in MailTo:' + Fsmtp.EnhCodeString);errorADDR_no:=1;exit;end;
    if not Fsmtp.MailData(msg_lines) then begin if SMTP_LOG_ERROR then LOG_STRING:=LOG_STRING+sToHeader+' [ERROR in MailData]'+#13#10;writeln('SMTP ERROR: for address: '+sToHeader+' in MailData:' + Fsmtp.EnhCodeString);errorADDR_no:=1;exit;end;
    ADDR_no:=1;
    if SMTP_LOG_SENT then LOG_STRING:=LOG_STRING+sToHeader+#13#10;
    end;
    writeln('');
    writeln('SMTP Logout');
    //if not Fsmtp.Logout() then begin writeln('SMTP ERROR: Logout:' + Fsmtp.EnhCodeString);exit;end;
    if not Fsmtp.Logout() then begin writeln('SMTP ERROR: Logout:' + Fsmtp.EnhCodeString);
    end else
    begin

    writeln('OK!');
    writeln('');
    end;
 

  finally
  
    
    if ADDR_no>0 then 
    begin
    //if not Fsmtp.Logout() then ;
    writeln('Total '+inttostr(ADDR_no)+' successfully sent.');
    writeln('Total '+inttostr(errorADDR_no)+' sent errors.');
    end;
    if (SMTP_LOG_FILE<>'')and(SMTP_LOG_SENT or SMTP_LOG_ERROR)and(LOG_STRING<>'')then 
    begin
    msg_lines.clear;
    //LOG_STRING:='<============ xfgmail 2 stated ['+datetostr(date)+'] ['+timetostr(now)+'] ============>'+#13#10+LOG_STRING;
    if fileexists(SMTP_LOG_FILE) then
    msg_lines.loadfromfile(SMTP_LOG_FILE);
    msg_lines.append(LOG_STRING);
    msg_lines.savetofile(SMTP_LOG_FILE);
    end;
    writeln('');
    writeln('cleaning up...');
    if msg_lines<>nil then begin msg_lines.Free;
    msg_lines:=nil;end;
    if msg_lines=nil then writeln('msg_lines = nil')else writeln('msg_lines <> nil');
    if ini<>nil then begin ini.Free;
    ini:=nil;end;
    if ini=nil then writeln('ini = nil')else writeln('ini <> nil');
  end;
end;

end.
